/*
 Copyright (c) 2013 OpenSourceRF.com.  All right reserved.
 
 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.
 
 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 See the GNU Lesser General Public License for more details.
 
 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 
 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
 CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

#import <QuartzCore/QuartzCore.h>

#import "AppViewController.h"
#import <UIKit/uikit.h>

@implementation AppViewController

@synthesize rfduino;

float diffusionCoeff = 0.7;
int verres = 0;
int capaciteVerre = 500;
float alcoolBiere = 0.06;
int valeurPoids = 70;
int tps = 0;

+ (void)load
{
    // customUUID = @"c97433f0-be8f-4dc8-b6f0-5343e6100eb4";
}

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
        /*
        UIButton *backButton = [UIButton buttonWithType:101];  // left-pointing shape
        [backButton setTitle:@"Disconnect" forState:UIControlStateNormal];
        [backButton addTarget:self action:@selector(disconnect:) forControlEvents:UIControlEventTouchUpInside];
        
        UIBarButtonItem *backItem = [[UIBarButtonItem alloc] initWithCustomView:backButton];
        
        [[self navigationItem] setLeftBarButtonItem:backItem];
        */
        [[self navigationItem] setTitle:@"Ecocup"];
        
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
    // Do any additional setup after loading the view from its nib.
 
    [rfduino setDelegate:self];
    
    valeurPoids = poidsSlider.value;
    [poids setText:[NSString stringWithFormat:@"%d kg", valeurPoids]];
    NSString* verresString = [NSString stringWithFormat:@"%d", verres];
    [nbVerres setText:verresString];
    updateAlcoolemie(taux);
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (IBAction)disconnect:(id)sender
{
    NSLog(@"disconnect pressed");

    [rfduino disconnect];
}

- (void)didReceive:(NSData *)data
{
    NSLog(@"RecievedRX");
    
    //verres = dataInt(data);
    uint8_t *p = (uint8_t*)[data bytes];
    
    verres = atoi((char*)p);
    tps = atoi((char*)p+3);
    
    int h = tps/3600;
    int m = (tps-h*3600)/60;
    int s = tps-h*3600-m*60;
    
    NSString* verresString = [NSString stringWithFormat:@"%d", verres];
    NSString* tpsString = [NSString stringWithFormat:@"%dh%dmin%ds", h, m, s];
    [nbVerres setText:verresString];
    [tpsEcoule setText:tpsString];
    updateAlcoolemie(taux);
}

- (IBAction)genderChanged:(id)sender {
    switch ([gender selectedSegmentIndex]) {
        case 0:
            diffusionCoeff = 0.7;
            break;
        case 1:
            diffusionCoeff = 0.6;
        default:
            break;
    }
    updateAlcoolemie(taux);
}

- (IBAction)weightChanged:(id)sender {
    valeurPoids = poidsSlider.value;
    [poids setText:[NSString stringWithFormat:@"%d kg", valeurPoids]];
    updateAlcoolemie(taux);
}

- (IBAction)capacityChanged:(id)sender {
    switch ([capacity selectedSegmentIndex]) {
        case 0:
            capaciteVerre = 250;
            break;
        case 1:
            capaciteVerre = 330;
            break;
        case 2:
            capaciteVerre = 500;
            break;
        default:
            break;
    }
    updateAlcoolemie(taux);
}

- (IBAction)refresh:(id)sender {
    uint8_t tx[1] = { "1" };
    NSData *data = [NSData dataWithBytes:(void*)&tx length:1];
    [rfduino send:data];
}

void updateAlcoolemie(UILabel* taux){
    float alcoolemie;
    NSString* alcoolemieString;
    alcoolemie = (verres*capaciteVerre*alcoolBiere*0.8)/(diffusionCoeff*valeurPoids);
    alcoolemieString = [NSString stringWithFormat:@"%.02f g/L", alcoolemie];
    [taux setText:alcoolemieString];
    if(alcoolemie > 0.5){
        UIColor *red = [UIColor colorWithRed:255.0/255.0 green:0/255.0 blue:0/255.0 alpha:1];
        taux.textColor = red;
    }
    else{
        UIColor *black = [UIColor colorWithRed:0.0/255.0 green:0.0/255.0 blue:0.0/255.0 alpha:1];
        taux.textColor = black;
    }
}

@end
